
var LoaderImgDir = 'img/';
var indicatorGrpPath = LoaderImgDir + 'loader_indicator.gif';
var completeGrpPath = LoaderImgDir + 'loader_complete.gif';
var errorGrpPath = LoaderImgDir + 'loader_error.gif';
var noMakeLoader = true;
var noShowLoader = true;
var LOADSTATUS = {
    ERROR: -1,
    LOADING: 0,
    SUCCESS: 1,
    RELOADING: 2
};


var errorFunc = function(err) {
    throw (err);
};

var ___LOADER___CHARSET = 'utf-8';
var REG_ID = /[^0-9a-zA-Z_\-\.]/;
var REG_IDDIR = /[^0-9a-zA-Z_\-\.\/]/;


function jQueryAddition() {
    jQuery.fn.enablize = function(flag) {
        if (flag) {
            this.removeAttr('disabled');
        } else {
            this.attr('disabled', 1);
        }
        return this;
    };
    jQuery.fn.mOffset = function () {
        var ofs = this.offset();
        var ml=this.css('margin-left');
        var mt=this.css('margin-top');
        ofs.left-=(ml.slice(0,-2)*1);
        ofs.top-=(mt.slice(0,-2)*1);
        return ofs;
    };
    jQuery.fn.setSelectable = function(flag) {
        if (flag) {
            this.prop('unselectable', false).css({
                MozUserSelect: 'text',
                khtmlUserSelect: 'text',
                KhtmlUserSelect: 'text',
                webkitUserSelect: 'text',
                userSelect: 'text'
            });
        } else {
            this.prop('unselectable', 'on').css({
                MozUserSelect: 'none',
                khtmlUserSelect: 'none',
                KhtmlUserSelect: 'none',
                webkitUserSelect: 'none',
                userSelect: 'none'
            });
        }
        return this;
    };
    jQuery.fn.innerOffset = function($parent,considerMargin) {
        if (!$parent) {
            $parent = this.parent();
        }
        var pofs,ofs;
        if (!considerMargin) {
            pofs = $parent.offset();
            ofs = this.offset();
        } else {
            pofs = $parent.mOffset();
            ofs = this.mOffset();
        }
        return {
            left: ofs.left - pofs.left +$parent.scrollLeft(),
            top: ofs.top - pofs.top+$parent.scrollTop()
        };
    };
    jQuery.fn.checkIt = function(flag) {
        if (flag) {
            this.attr('checked', 1);
        } else {
            this.removeAttr('checked');
        }
        return this;
    };
    jQuery.Event.prototype.prevent = Event.prototype.prevent;
    jQuery.fn.unbinds = function(commaListedStrings) {
        var ar = commaListedStrings.split(/ *\, */);
        for (var i = 0; i < ar.length; i++) {
            this.unbind(ar[i]);
        }
        return this;
    };
    jQuery.fn.addClasses = function(_array) {
        for (var i = 0; i < _array.length; i++) {
            this.addClass(_array[i]);
        }
        return this;
    };
    jQuery.fn.removeClasses = function(_array) {
        for (var i = 0; i < _array.length; i++) {
            this.removeClass(_array[i]);
        }
        return this;
    };
    jQuery.fn.classFlag = function(className, flag) {
        // flagのtrue/ falseでclassNameを切り貼りする
        if (flag) {
            this.addClasses([].concat(className));
        } else {
            this.removeClasses([].concat(className));
        }
        return this;
    };

    jQuery.fn.outerHTML = function(mytext) {
        this.after(mytext).remove();
    };

    jQuery.fn.escapeHTML = function(val) {
        return $('<p>').text(val).html();
    };
    jQuery.fn.unescapeHTML = function(val) {
        return $('<p>').html(val).text();
    };
    jQuery.fn.SQ = function(v1, v2, v3, v4) {

        if (!$.fn.finish) {
            try {
                while (this.queue().length) {
                    this.stop(true, false);
                }
            } catch (err) {
                this.stop(true, false);
                this.stop(true, false);
                this.stop(true, false);
                this.stop(true, false);
                this.stop(true, false);
            }
            return this;
        } else {
            return this.finish();
        }
    };
    jQuery.fn.SANM = function(v1, v2, v3, v4) {
        return this.SQ().animate(v1, v2, v3, v4);
    };
    jQuery.fn.delay = function(_time, _func) {
        return this.animate({
            backgroundPositionX: '+=0'
        }, _time, undefined, _func);
    };
    jQuery.fn.$MK = function() {
        return $MK.apply(this, arguments).appendTo(this);
    };
    jQuery.fn.$MK_dupe = function(attrA, _obj) {
        return $MK_dupe(this, attrA, _obj);
    };
    jQuery.fn.Data = function(_k, _v) {
        if (_v === undefined) {
            if (this.length == 1) return $.data(this.get(0), _k);
            if (this.length === 0) return undefined;
            var ret = [];
            this.each(function() {
                ret.push($.data(this, _k));
            });
            return ret;
        }
        this.each(function() {
            $.data(this, _k, _v);
        });
        return this;
    };

}

// _______ === 汎用 === _____ //

function objDupe(srcObject) {
    var newObj = {};
    for (var i in srcObject) {
        newObj[i] = srcObject[i];
    }
    return newObj;
}

function objDupe2(srcObject, objectKeys) {
    // objectKeys: srcObjectの要素のうち Object であるもの。
    // objectに対しdupe命令を送る。
    var newObj = {};
    for (var i in srcObject) {
        if (isin(i, objectKeys) >= 0) {
            try {
                if (srcObject[i].class() != 'Array') {
                    throw 0;
                }
                newObj[i] = objArrayDupe(srcObject[i]);
            } catch (err) {
                newObj[i] = srcObject[i].dupe();
            }
        } else {
            try {
                if (newObj[i].class() != 'Array') {
                    throw 0;
                }
                newObj[i] = arrayDupe(srcObject[i]);
            } catch (err) {
                newObj[i] = srcObject[i];
            }
        }
    }
    return newObj;
}

var Class_TOEV = function() {
        this.task = {};
        this.___clr___ = function(key) {
            key = escape(key);
            if (this.task[key] !== undefined) {
                var k = objDupe(this.task[key]);
                delete this.task[key];
                return k;
            }
            return undefined;
        };
        // 外から呼び出せる関数
        this.set = function(key, evnt, _time, isInterval) {
            this.del(key);
            key = escape(key);
            var _intv;
            if (isInterval) {
                this.task[key] = {
                    data: evnt,
                    time: _time,
                    ev: setInterval(evnt, _time),
                    isInterval: 1
                };
            } else {
                var ev;
                if (typeof(evnt) == "string") {
                    ev = setTimeout("TOEV.___clr___('" + key + "');" + evnt, _time);
                } else {
                    //function
                    ev = setTimeout(function() {
                        var f = TOEV.task[key].data;
                        TOEV.___clr___(key);
                        f();
                    }, _time);
                }
                this.task[key] = {
                    data: evnt,
                    time: _time,
                    ev: ev,
                    isInterval: 0
                };
            }
        };
        this.doit = function(key) {
            var _ev = this.del(key);
            if (_ev) {
                var evnt = _ev.data;
                if (_ev.isInterval) {
                    this.set(key, _ev.data, _ev.time, _ev.isInterval);
                } else {
                    this.___clr___(key);
                }
                if (typeof(evnt) == "string") {
                    return eval(evnt);
                } else {
                    //function
                    return evnt();
                }
            }
        };
        this.del = function(key) {
            var k = this.___clr___(key);
            if (k !== undefined) {
                if (k.isInterval) {
                    clearInterval(k.ev);
                } else {
                    clearTimeout(k.ev);
                }
                return k;
            }
            return undefined;
        };
        this.isin = function(key) {
            key = escape(key);
            return (this.task[key] !== undefined);

        };
    };
var TOEV = new Class_TOEV();

/* ___ QUERY ___ */

var QUERY = function() {
    var lc;
    var lca = {};
    var refine = function(loadQuery) {
        // loadQuery : location.searchのかわりにくわせる
        lc = loadQuery = (loadQuery !== undefined) ? (loadQuery) : (location.search);;
        lca = {};
        if (lc) {
            var lcs = lc.slice(1).split('&');
            for (var i = 0; i < lcs.length; i++) {
                var v = lcs[i];
                if (v.match(/\=/)) {
                    lca[decodeURIComponent(RegExp.leftContext)] = decodeURIComponent(RegExp.rightContext);
                }
            }
        }
    };
    window.addEventListener('popstate', function(e) {
        refine();
    }, false);
    var getQuery = function(_key, _defval) {
        return get(lca, _key, _defval);
    };
    var setQuery = function(_key, _val) {
        lca[_key] = _val;
    };
    refine();
    return {
        refine: refine,
        get: getQuery,
        set: setQuery,
        getAll: function() {
            return lca;
        }
    };
}();
function queryGet (key,_defval) {
    if(!key) return '';
    return QUERY.get(key,_defval);
}



function $MakeSpan(_obj) {
    _obj.TAG = 'span';
    return $Make(_obj);
}

function $MakeDiv(_obj) {
    _obj.TAG = 'div';
    return $Make(_obj);
}


var $Make = function() {
    var tagname;
    var _obj;
    var Regs = [];
    var addReg = function(char, attrname, allow_all_char) {
        Regs.push([
            new RegExp('\\' + char + '[ \\s\\t]*' + (!allow_all_char ? '([\\w_\\-]*)' : '(.*)') + '[ \\s\\t]*'),
            attrname
        ]);
        return addReg;
    };
    addReg('>>', 'HTML', true)('>', 'TEXT', true)('#', 'id')(':', 'type')('=', 'value')('@', 'alt')('~', 'name');
    var reg_len = Regs.length;
    return function execute_Make(_tagname, __obj) {

        tagname = _tagname;
        _obj = __obj;
        /*_obj:
            $Make('span',{CSS:{}, alt:'...'})
            $Make('span#id.class.class2')

            $Make('input:checkbox=value')
                = value
                ~ name
                @ alt
                > TEXT テキストの最後に持ってくること
                >> HTML

            TAG: 'span' ,'pre' など。省略時 div
            CSS: cssを設定
            TEXT: text
            CLASS: ['class1','class2'] or 'class1,class2'
            HTML
             */
        if (typeof(tagname) == 'string') {
            _obj = (_obj !== undefined) ? (_obj) : ({});
        } else {
            //object
            _obj = tagname;
            tagname = get(_obj, "TAG", "");

        }
        for (var j = 0; j < reg_len; j++) {
            if (tagname.match(Regs[j][0])) {
                if (RegExp.$1) {
                    _obj[Regs[j][1]] = RegExp.$1;
                }
                tagname = RegExp.leftContext + RegExp.rightContext;
            }
        }
        var appendClasses = [];
        if (tagname.match(/\.([\w_\-\.\, \s\t]*)/)) {
            tagname = RegExp.leftContext + RegExp.rightContext;
            appendClasses = RegExp.$1.split(/[ \s\t\,\.]+/).removeEmpty();
        }
        tagname = (tagname) ? (tagname) : ('div');
        var $e = $('<' + tagname + ' />').addClasses(appendClasses);
        if (tagname.match(/^table/i)) {
            objMerge(_obj, {
                cellspacing: 0,
                cellpadding: 0,
                margin: 0
            }, true);
        }
        if (tagname.match(/^canvas/i)) {
            _obj.width = (_obj.width !== undefined) ? (_obj.width) : (get2(_obj, 'CSS', 'width', 100));
            _obj.height = (_obj.height !== undefined) ? (_obj.height) : (get2(_obj, 'CSS', 'height', 100));
        }
        for (var k in _obj) {
            if (k == 'TAG') {
                continue;
            }
            if (k == 'CSS') {
                if (_obj[k]) $e.css(_obj[k]);
            } else if (k == 'TEXT') {
                $e.text(_obj[k]);
            } else if (k == 'HTML') {
                $e.html(_obj[k]);
            } else if (k == 'APPEND') {
                if (_obj[k]) $e.append(_obj[k]);
            } else if (k == 'CLASS') {
                if (_obj[k]) $e.addClasses(_obj[k].makeArray(/[\.\, \s\t]+/));
            } else if (k == 'CLICK' || k == 'MOUSEDOWN' || k == 'MOUSEUP' || //
                k == 'MOUSEMOVE' || k == 'MOUSEOVER' || k == 'MOUSEOUT' || //
                k == 'FOCUS' || k == 'BLUR' || k == 'KEYDOWN' || //
                k == 'KEYPRESS' || k == 'KEYUP' || k == 'RESIZE' || k == 'SCROLL' || k == 'CHANGE') {
                $e.bind(k.toLowerCase(), _obj[k]);
            } else if (k == 'VOIDHREF' && tagname == 'a') {
                $e.attr('href', voidJSHref);
            } else if (k == 'CLEAR') {
                $e.css('clear', 'both');
            } else {
                $e.attr(k, _obj[k]);
            }

        }
        return $e;

    };
}();

function $MKdv(_obj) {
    return $MakeDiv.apply(this, arguments);
}

function $MKsp(_obj) {
    return $MakeSpan.apply(this, arguments);
}

function $MK(_obj) {
    return $Make.apply(this, arguments);
}

function $MK_dupe($src, attrA, _obj) {
    // 特定要素をコピーしての複製
    var objb = {};
    $.each(attrA, function(i, k) {
        objb[k] = $src.attr(k);
    });
    objb['TAG'] = $src.prop('tagName');
    return $Make(objMerge(objb, _obj));
}


Event.prototype.prevent = function() {
    try {
        this.preventDefault();
    } catch (err) {}
    try {
        this.stopPropagation();
    } catch (err) {}
};


/* ___ 汎用:Date ___ */
Date.prototype.YYMMDD = function(separator) {
    separator = separator === undefined ? '/' : separator;
    return (this.getYear() - 100) + separator + (this.getMonth() + 1).getN(2) + separator + (this.getDate()).getN(2);
};
Date.prototype.hhmmss = function() {
    return (this.getHours().getN(2)) + ':' + (this.getMinutes()).getN(2) + ':' + (this.getSeconds()).getN(2);
}; /* ___ 汎用:Number ___ */
Number.prototype.getN = function(keta) {
    var tmp = this + '';
    while (tmp.length < keta) {
        tmp = "0" + tmp;
    }
    return tmp;
}

function BTW(a, x, b) {
    return (a <= x && x < b);
}

function BTWs(a, x, b) {
    return (a < x && x < b);
}

function BTWl(a, x, b) {
    return (a <= x && x <= b);
}

function floor2(v, keta) {
    // keta==2 なら小数点2位まで表示
    keta = (keta !== undefined) ? (int(keta)) : (0);
    if (keta <= 0) {
        return Math.floor(v);
    }
    var v2 = Math.floor((v + 1) * Math.pow(10, keta));
    var syosu = '.' + (v2 + '').slice(-keta);
    return (Math.floor(v)) + syosu;
}

/* ___ 汎用:string ___ */
String.prototype.path2Id = function() {
    return this.replace(/\-/g, '_').replace(/^\.\//, '').
    replace(/\.\.\//g, '--').replace(/[^A-Za-z0-9_]/g, '_');
};
String.prototype.path2Class = function() {
    return this.replace(/\-/g, '_').replace(/[\t \s]/g, '').replace(/^\.\//, '').
    replace(/\.\.\//g, '--').replace(/[^A-Za-z0-9_]/g, '_');
};

String.prototype.matchA = function(patternArray) {
    var it;
    for (var i = 0; i < patternArray.length; i++) {
        if ((it = this.match(patternArray[i]))) {
            return it;
        }

    }
    return undefined;
};

function Num2DateString(y, m, d, separator) {
    separator = (separator !== undefined) ? (separator) : ('/');
    return Spr(int(y) % 100, 2) + separator + Spr(int(m), 2) + separator + Spr(int(d), 2);

}

function Num2HHMMString(HH, MM, separator) {
    separator = (separator !== undefined) ? (separator) : (':');
    return Spr(int(HH + int(MM / 60)) % 24, 2) + separator + Spr(int(MM) % 60, 2);

}

function bitsToArray(bits, maxitem) {
    // ビット列をboolean配列に
    var ret = (maxitem) ? (makeEmptyArray(maxitem, false)) : [];
    var i = 0;
    bits = int(Math.abs(bits));
    while (bits) {
        ret[i] = bits & 1 ? true : false;
        bits = bits >> 1;
        i++;
    }
    return ret;
}

function arrayToBits(array, maxitem) {
    // boolean配列をビット列に
    var ret = 0;
    var i = maxitem ? maxitem : array.length;
    while (i > 0) {
        ret = ret << 1;
        i--;
        ret += array[i] ? 1 : 0;
    }
    return ret;
}

/* ___ 汎用:配列系 ___ */

function get(obj, key, defitem) {
    try {
        if (obj[key] === undefined) {
            throw 0;
        }
        return obj[key];
    } catch (err) {
        return defitem;
    }
}

function get2(obj, key1, key2, defitem) {
    try {
        if (obj[key1] === undefined) {
            throw 0;
        }
        if (obj[key1][key2] === undefined) {
            throw 0;
        }
        return obj[key1][key2];
    } catch (err) {
        return defitem;
    }
}

function get3(obj, key1, key2, key3, defitem) {
    try {
        if (obj[key1] === undefined) {
            throw 0;
        }
        if (obj[key1][key2] === undefined) {
            throw 0;
        }
        if (obj[key1][key3] === undefined) {
            throw 0;
        }
        return obj[key1][key2][key3];
    } catch (err) {
        return defitem;
    }
}

function objMerge(descObject, srcObject, noReplace) {
    // noReplace: trueを与えると既存項目を置き換えない
    if (!descObject) {
        return (srcObject !== undefined) ? (srcObject) : ({});
    }
    if (!srcObject) {
        return descObject;
    }
    for (var i in srcObject) {
        if (noReplace) {
            if (descObject[i] !== undefined) {
                continue;
            }
        }
        descObject[i] = srcObject[i];
    }
    return descObject;
}

function objHasDifferentItem(checkedObject, myObject, noCheckUndef) {
    // noCheckUndef: 「片側にしか無い要素」はチェックしない。
    // differentであった場合myObjectを返却する
    var j;
    if (!checkedObject) {
        return myObject;
    }
    for (j in myObject) {
        if (checkedObject[j] === undefined && noCheckUndef) {
            continue;
        }
        if (checkedObject[j] !== myObject[j]) {
            return myObject;
        }
    }
    if (!noCheckUndef) {
        for (j in checkedObject) {
            if (checkedObject[j] !== myObject[j]) {
                return myObject;
            }
        }
    }
    return false;
}

function everyItem(srcObjectArray, _key) {
    // srcObjectArray: [ {_key:1}, {_key:2}, ... ]
    // return [1,2,...]
    var ar = [];
    for (var i = 0; i < srcObjectArray.length; i++) {
        ar.push(srcObjectArray[i][_key]);
    }
    return ar;
}

function everyItemEv(srcObjectArray, _evalkey) {
    // srcObjectArray: [ {_key:function(){return 1;}}, {_key:function(){return 2;}}, ... ]
    // everyItemEv(srcObjectArray, '_key();')
    // return [1,2,...]
    var ar = [];
    for (var i = 0; i < srcObjectArray.length; i++) {
        ar.push(eval('srcObjectArray[' + i + '].' + _evalkey));
    }
    return ar;
}

function int(num) {
    return Math.floor(Nm(num));
}

function intN(num) {
    return (num < 0) ? Math.ceil(Nm(num)) : Math.floor(Nm(num));
}

function intC(num) {
    return Math.ceil(Nm(num));
}


function Nm(num, isNaNdefault, emptyDefault) {
    // emptyDefault:: num===''ならisNanDefaultを返す
    isNaNdefault = ((isNaNdefault === undefined) ? 0 : isNaNdefault);
    if (num === '' && emptyDefault) {
        return isNaNdefault;
    }
    num *= 1;
    return isNaN(num) ? isNaNdefault : num;
}

function Spr(x, keta) {
    x = x + '';
    var pketa = x.split('').length;
    for (var i = pketa; i < keta; i++) {
        x = '0' + x;
    }
    return x;
}

function makeEmptyArray(num, youso, concatArray) {
    var ar = [];
    while (num > 0) {
        num--;
        ar.push(youso);
    }
    if (concatArray) {
        return ar.concat(concatArray);
    }
    return ar;
}

// 要素がarrayの場合の実行。

function makeEmptyArrayA(num, yousoA, concatArray) {
    var ar = [];
    while (num > 0) {
        num--;
        ar.push([].concat(yousoA));
    }
    if (concatArray) {
        return ar.concat(concatArray);
    }
    return ar;
}

function makeCountUpArray(num, start, cup) {
    // numに負数を渡すと「値がその数値になるまで」をカウントする。
    var ar = [];
    if (start === undefined) {
        start = 0;
    }
    if (cup === undefined) {
        cup = 1;
    }
    var last;
    if (num < 0) {
        last = -num;
    }
    while (num) {
        num--;
        ar.push(start);
        start += cup;
        if (last !== undefined) {
            if (start >= last) {
                break;
            }
        }
    }
    return ar;
}




function isina(x, ar, akey, _findAll) {
    // 配列arの要素XXのアイテムakeyに文字列xが含まれているか否か
    var rar = -1;
    if (_findAll) {
        rar = [];
    }
    for (var i = 0; i < ar.length; i++) {
        if (x == ar[i][akey]) {
            if (_findAll) {
                rar.push(i);
            } else {
                return i;
            }
        }
    }
    return rar;
}

function isinEv(x, ar, evkey, _findAll) {
    // 配列arの要素XXのアイテムakeyに文字列xが含まれているか否か
    var rar = -1;
    if (_findAll) {
        rar = [];
    }
    for (var i = 0; i < ar.length; i++) {
        if (x == eval('ar[' + i + '].' + evkey)) {
            if (_findAll) {
                rar.push(i);
            } else {
                return i;
            }
        }
    }
    return rar;
}

Array.prototype.isin = function(x) {
    // 配列arに文字列xが含まれているか否か
    for (var i = 0; i < this.length; i++) {
        if (x == this[i]) {
            return i;
        }
    }
    return -1;
};
Array.prototype.isinObj = function(x) {
    // obj的な[name,val] に対して要素の存在をチェックする
    for (var i = 0; i < this.length; i++) {
        if (x == this[i][0]) {
            return i;
        }
    }
    return -1;
};
Array.prototype.getO = function(x, defaultValue) {
    // obj的な[name,val] に対して要素の存在をチェックする
    for (var i = 0; i < this.length; i++) {
        if (x == this[i][0]) {
            return this[i][1];
        }
    }
    return defaultValue;
};
Array.prototype.setO = function(x, val) {
    // obj的な[name,val] に対して要素の存在をチェックする
    for (var i = 0; i < this.length; i++) {
        if (x == this[i][0]) {
            this[i][1] = val;
            break;
        }
    }
    return this;
};
Array.prototype.pushA = function(_array) {
    for (var i = 0; i < _array.length; i++) {
        this.push(_array[i]);
    }
    return this;

};

Array.prototype.pushIdentical = function(x) {
    if (this.isin(x) == -1) {
        this.push(x);
        return x;
    }
    return undefined;
};
Array.prototype.pushIdenticalA = function(_array) {
    for (var i = 0; i < _array.length; i++) {
        this.pushIdentical(_array[i]);
    }
    return this;

};


Array.prototype.pushIdenticalAndSort = function(x, fn) {
    this.pushIdentical(x);
    return this.sort(fn);
};
Array.prototype.pushIdenticalAndSortN = function(x) {
    this.pushIdentical(x);
    return this.sortN();
};

Array.prototype.pushIdenticalAndSortNR = function(x) {
    this.pushIdentical(x);
    return this.sortNR();
};

Array.prototype.spliceA = function(sa, sb, Ar) {
    // spliceで第三引数以降の代わりにArを用いる
    // spliceとは挙動が異なり, ar=ar.spliceA(...)と実行すること
    return this.slice(0, Math.max(0, sa)).concat(Ar).concat(this.slice(sa + Math.max(0, sb)));
};




Array.prototype.numberize = function(defval) {
    for (var i = 0; i < this.length; i++) {
        this[i] = Nm(this[i], defval);
    }
    return this;
};



Array.prototype.integerize = function(x, defval) {
    for (var i = 0; i < this.length; i++) {
        this[i] = int(this[i]);
    }
    return this;
};
Array.prototype.multiplize = function(x) {
    for (var i = 0; i < this.length; i++) {
        this[i] = Nm(this[i] * x);
    }
    return this;
};


Array.prototype.sum = function() {
    var r = 0;
    for (var i = 0; i < this.length; i++) {
        r += this[i];
    }
    return r;
};

Array.prototype.sortN = function() {
    // numeric sort
    this.sort(function(a, b) {
        return (a == b) ? 0 : ((a > b) ? 1 : -1);
    });
    return this;
};

Array.prototype.deleteSpecific = function(_val) {
    var i = 0;
    while (i < this.length) {
        if (this[i] === _val) {
            this.splice(i, 1);
        } else {
            i++;
        }
    }
    return this;
};

Array.prototype.sortNR = function() {
    // numeric sort
    this.sort(function(a, b) {
        return (a == b) ? 0 : ((a > b) ? -1 : 1);
    });
    return this;
};
Array.prototype.sortFromArray = function(_ar) {
    var _nar = [];
    for (var i = 0; i < _ar.length; i++) {
        _nar.push(this[_ar[i]]);
    }
    for (var i = 0; i < _nar.length; i++) {
        this[i] = _nar[i];
    }
    this.splice(_nar.length);
    return this;
};


// 空要素を削除 デフォルトは undefined か空文字列
Array.prototype.removeEmpty = function ___Array_prototype_removeEmpty(checkFn) {
    checkFn = (checkFn !== undefined) ? (checkFn) : (function(_item) {
        return _item === undefined || _item === '';
    });
    var i = 0;
    while (i < this.length) {
        if (checkFn(this[i])) {
            this.splice(i, 1);
        } else {
            i++;
        }
    }
    return this;
}


Event.prototype.prevent = function() {
    try {
        this.preventDefault();
    } catch (err) {}
    try {
        this.stopPropagation();
    } catch (err) {}
};

function arrayDupe(srcArray, lgt) {
    var newArray = [];
    try {
        if (lgt === undefined) {
            lgt = srcArray.length;
        }
        for (var i = 0; i < lgt; i++) {
            newArray[i] = srcArray[i];
        }
    } catch (err) {}
    return newArray;
}

function objArrayDupe(srcArray, lgt) {
    var newArray = [];
    try {
        if (lgt === undefined) {
            lgt = srcArray.length;
        }
        for (var i = 0; i < lgt; i++) {
            newArray[i] = srcArray[i].dupe();
        }
    } catch (err) {}
    return newArray;
}

// ___ color ___ //

function level2color(v) {
    // [0-255,0-255,0-255] を  #rrggbb に
    var r = '#';
    for (var i = 0; i < 3; i++) {
        var vl = MMX(0, ranNm(v[i]) * 1, 255);
        if (vl < 16) {
            r += '0';
        }
        r += vl.toString(16);
    }
    return r ;
}

function color2level(colorcode) {
    // #rrggbb を [0-255,0-255,0-255]に
    if (colorcode.match(/^\#?([a-fA-F0-9]{2})([a-fA-F0-9]{2})([a-fA-F0-9]{2})?/)) {
        return [parseInt(RegExp.$1, 16), parseInt(RegExp.$2, 16), parseInt(RegExp.$3, 16)];
    }
    return [0, 0, 0];
}


function HSV2COL(h, s, v) {
    return level2color(HSV2RGB(h, s, v));

}

function COL2HSV(colorcode) {
    return RGB2HSV(color2level(colorcode));
}

function RGB2HSV(r, g, b) {
    // [h(0-360),s(0-100),v (0-100) ]を返却
    if (r.class() == 'Array') {
        g = r[1];
        b = r[2];
        r = r[0];
    }
    r = ranNm(r) / 256;
    g = ranNm(g) / 256;
    b = ranNm(b) / 256;

    var _max = Math.max(Math.max(r, g), b);
    var _min = Math.min(Math.min(r, g), b);
    var h, s, v;
    switch (_min) {
    case _max:
        h = 0;
        break;
    case b:
        h = 60 * (g - r) / (_max - _min) + 60;
        break;
    case r:
        h = 60 * (b - g) / (_max - _min) + 180;
        break;
    case g:
        h = 60 * (r - b) / (_max - _min) + 300;
        break;

    }
    var s = (_max - _min) / _max;
    return [h, s * 100, _max * 100];

}

function HSV2RGB(h, s, v) {
    // h: 0-360
    // s:1-100
    // v:1-100
    h = ranNm(h);
    s = ranNm(s) / 100;
    v = ranNm(v) / 100;
    while (h < 0) {
        h += 360;
    }
    while (h > 360) {
        h -= 360;
    }
    var C = v * s; // 円柱モデル
    var hd = h / 60;
    var X = C * (1 - Math.abs(hd % 2 - 1));
    var ap;
    if (hd <= 1) {
        ap = [C, X, 0];
    } else if (hd <= 2) {
        ap = [X, C, 0];
    } else if (hd <= 3) {
        ap = [0, C, X];
    } else if (hd <= 4) {
        ap = [0, X, C];
    } else if (hd <= 5) {
        ap = [X, 0, C];
    } else {
        ap = [C, 0, X];
    }
    var vc = v - C;
    return [(vc + ap[0]) * 256, (vc + ap[1]) * 256, (vc + ap[2]) * 256];



}



/* ___ 汎用:マウス位置取得用関数 ___ */

function Intension(wdt, hgt, maxwdt, maxhgt) {
    var lvl = 1;
    if (wdt > maxwdt) {
        lvl = maxwdt / wdt;
        wdt *= lvl;
        hgt *= lvl;
    }
    lvl = 1;
    if (hgt > maxhgt) {
        lvl *= maxhgt / hgt;
        wdt *= lvl;
        hgt *= lvl;

    }
    return [int(wdt), int(hgt)];
}

function ROTA2(_ary, agR) {
    return [_ary[0] * Math.cos(agR) - _ary[1] * Math.sin(agR), _ary[0] * Math.sin(agR) + _ary[1] * Math.cos(agR)];
}

function ZMA2(_ary, zmx, zmy) {
    if (zmy === undefined) {
        zmy = zmx;
    }
    return [_ary[0] * zmx, _ary[1] * zmy];
}

//マウスX座標get

function mousex(e) {
    if (document.all) //e4,e5,e6用
    return _canvas.scrollLeft + event.clientX;
    else if (document.getElementById) //n6,n7,m1,o7,s1用
    return e.pageX;
}
//マウスY座標get

function mousey(e) {
    if (document.all) //e4,e5,e6用
    return _canvas.scrollTop + event.clientY;
    else if (document.getElementById) //n6,n7,m1,o7,s1用
    return e.pageY;
}

function GAR(xloc1, yloc1, xloc2, yloc2) {
    return (Math.atan2((yloc2) - (yloc1), (xloc2) - (xloc1)));
}

function LENGTHXY(the_x1, the_y1, the_x2, the_y2) {
    return (Math.sqrt(Math.pow((the_x1) - (the_x2), 2) + Math.pow((the_y1) - (the_y2), 2)));
}

function absmin(val, a) {
    if (val < 0) {
        return Math.max(val, -a);
    }
    return Math.min(val, a);

}

function ranNm(v, defaultValue) {
    // 振れ幅コミの値設定
    // '3+-1' で2以上4未満の値を得る
    try {
        if (v.match(/\+\-/)) {
            return Nm(RegExp.leftContext * 1 + (Math.random() - 0.5) * 2 * (RegExp.rightContext), defaultValue);
        }
    } catch (err) {
        return Nm(v, defaultValue);
    }
}


function tEval(val, defaultValue) {
    try {
        if (val === undefined) {
            throw 0;
        }
        return eval('(' + val + ')');
    } catch (err) {
        if (defaultValue === undefined && $.trim(val) !== "") {
            errorFunc('tEval error:: script:' + val);
        }
        return defaultValue;
    }
}



function MMX(a, v, b) {
    if (v < a) {
        return a;
    }
    if (v > b) {
        return b;
    }
    return v;
}

function absmax(val, a) {
    if (val < 0) {
        return Math.min(val, -a);
    }
    return Math.max(val, a);
}

function correctangleD(agD) {
    agD = Nm(agD);
    while (agD >= 180) {
        agD -= 360;
    }
    while (agD < -180) {
        agD += 180 * 2;
    }
    return agD;
}

function correctangle01(ag01) {
    ag01 = Nm(ag01);
    while (ag01 >= 0.5) {
        ag01 -= 1;
    }
    while (ag01 < -0.5) {
        ag01 += 1;
    }
    return ag01;
}


// className
String.prototype.class = function() {
    return 'String';
};
Array.prototype.class = function() {
    return 'Array';
};
Boolean.prototype.class = function() {
    return 'Boolean';
};
Date.prototype.class = function() {
    return 'Date';
};
Number.prototype.class = function() {
    return 'Number';
};
Function.prototype.class = function() {
    return 'Function';
};
RegExp.prototype.class = function() {
    return 'RegExp';
};

String.prototype.getJSString = function() {
    return '"' + this.replace(/\"/g, "\\\"").replace(/\r/g, "\\r").replace(/\n/g, "\\n") + '"';
};
Number.prototype.getJSString = function() {
    return this + '';
};
Boolean.prototype.getJSString = function() {
    return this + '';
};
Date.prototype.getJSString = function() {
    return 'new Date().setTime(' + (this.getTime()) + ')';
};
Function.prototype.getJSString = function() {
    return this.toString();
};
RegExp.prototype.getJSString = function() {
    return this.toString();
};
Array.prototype.getJSString = function() {
    var ar = [];
    for (var i = 0; i < this.length; i++) {
        ar.push(getJSString(this[i]));
    }
    return '[' + ar.join(', ') + ' ]';
};




Number.prototype.json_encode = Number.prototype.getJSString;
String.prototype.json_encode = function() {
    return this.getJSString().replace(/\'/g, '\\"');
}
Boolean.prototype.json_encode = Boolean.prototype.getJSString;
Array.prototype.json_encode = function() {
    var ar = [];
    for (var i = 0; i < this.length; i++) {
        ar.push(json_encode(this[i]));
    }
    return '[' + ar.join(', ') + ' ]';
};





String.prototype.fullDupe = function() {
    return this + '';
};
Number.prototype.fullDupe = function() {
    return this + 0;
};
Boolean.prototype.fullDupe = function() {
    return (this.toString() == 'true') ? true : false;
};
Date.prototype.fullDupe = function() {
    return this;
};
Function.prototype.fullDupe = function() {
    return this;
};
RegExp.prototype.fullDupe = function() {
    return this;
};
Array.prototype.fullDupe = function() {
    var ar = [];
    for (var i = 0; i < this.length; i++) {
        ar.push(fullDupe(this[i]));
    }
    return ar;
};




function getJSString(_var) {
    if (_var === undefined) {
        return 'undefined';
    } else {
        try {
            return _var.getJSString();
        } catch (err) {
            // object型
            return getJSStringObj(_var);
        }
    }
}

function getJSStringObj(_obj) {
    var ar = [];
    for (var i in _obj) {
        ar.push((i) + ':' + getJSString(_obj[i]));
    }
    return '{' + ar.join(' ,') + '} ';
}

function json_encode(_var) {

    if (_var === undefined) {
        return 'undefined';
    } else {
        try {
            return _var.json_encode();
        } catch (err) {
            // object型
            return jsonEncodeObj(_var);
        }
    }
}

function jsonEncodeObj(_obj) {
    var ar = [];
    for (var i in _obj) {
        ar.push('"' + i + '"' + ':' + json_encode(_obj[i]));
    }
    return '{' + ar.join(' ,') + '} ';
}

function fullDupe(_var) {
    if (_var === undefined) {
        return;
    } else {
        try {
            return _var.fullDupe();
        } catch (err) {
            // object型
            return fullDupeObj(_var);
        }
    }

}

function fullDupeObj(_obj) {
    var ar = {};
    for (var i in _obj) {
        ar[i] = fullDupe(_obj[i]);
    }
    return ar;
}
